// контроль нуля идет на 1-е прерывание (это pin 3)
// Управление симистором для фазового регулятора мощности реализовано через PIN 11
// АЦП от трансформатора подключен на pin А2 (раньше шел на pin A3)

// Кнопки подключены на следующие пины:
// почему на этих - да потому, что они рядом идут, и еще пин земли рядом, а гребенку 6 онтактов проще паять и подключать, чем каждый контакт одтельно
// PIN_SELECT 53
// PIN_RIGHT 51
// PIN_LEFT 49
// PIN_UP 45
// PIN_DOWN 47

// Почему-то иногда глючит дисплей - когда это происходит (на нем появляются иероглифы или перестает отображаться текст),
// нажать и держать одновременно клавишу влево и вправо, дисплей переинициализируется.

// одновременное нажатие кнопок вверх и вних позволчет перейти к следующему этапу процесса ректификации.


// Клапана для управления ШИМ подключены, начиная с PIN 22
// Всего максимум 5 клапанов, то есть на пины с 22 по 26 реализован
// программный ШИМ по количество полупериодов с контролем нуля.


// Дисплей на следующих пинах - почему на этих - да потому, что они рядом идут, и еще пин земли рядом, как раз для вывода R/W дисплея
// а гребенку из 7 контактов проще паять и подключать, чем каждый контакт одтельно
// LiquidCrystal lcd(52,50, 48, 46, 44, 42);
// Датчики ds18b20 сидят на 10 пине.
//OneWire  ds(10);  // on pin 10


#include <LiquidCrystal.h>
#include <OneWire.h>

#include <EEPROM.h> 

#define PR_REWRITE_EEPROM 4  // Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254). 
                             // При запуске программы, значение 0-го байта ЕЕПРОМ сравнивается с этим знначением, 
                             // и если они не совпадают, тогда энергонезависимая памиять переписывается текущими значениями переменных
                             // То есть для перезаписи контанты при первом запуске, ее значение надо поменять

unsigned int ee_addr; // Переменная для хранения текущего адреса чтения/записи в EEPROM

unsigned char eeReadChar()
  {
    unsigned char lByte = EEPROM.read(ee_addr);
    ee_addr++;
    return lByte;
  }

void eeWriteChar(char p_value)
  {
    if (EEPROM.read(ee_addr)!=p_value)
                      EEPROM.write(ee_addr, p_value);
    ee_addr++;
  }

void eeWriteInt(int p_value)
  {
    unsigned char lByte = (unsigned char) (p_value);
    unsigned char hByte =(unsigned char) (p_value >> 8);
    
    // Для экономии ресурса памяти, сначала проверяем ее содержимое и запись производим только если значение отличается.
    eeWriteChar(lByte);
    eeWriteChar(hByte);
  }

//This function will read a 2 byte integer from the eeprom at the specified address and address + 1
unsigned int eeReadInt()
  {
    unsigned char lByte = eeReadChar();
    unsigned char hByte = eeReadChar();
    return (unsigned int) (lByte) | (unsigned int)  (hByte << 8);
  }
        

#define MAX_INDEX_INPUT 70
//#define TEST   // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TIMING  // Признак выдачи времени выполнения различных операций информации через Serial1 (раскомментировать, если нужно, но работа программы будет неправильной.

unsigned int data_adc[MAX_INDEX_INPUT+1];
unsigned int tic_adc[MAX_INDEX_INPUT+1];
char lcd_buffer[33]; //Буфер для хранения данных для вывода на дисплей

#define RX_BUFFER_SIZE 35
char my_rx_buffer[RX_BUFFER_SIZE];
char my_tx_buffer[RX_BUFFER_SIZE];

int  FlState=0;  // Флаг состоянияч конечного автомата обработки нажатия кнопок клавиатуры 
char  IspReg=101; // Используемый в данный момент режим (по умолчанию пока ставим регулятор мощности)
char  DispPage=0; // Какую страницу отображать на дисплее
int TempTerm=200;
int TempMax=0;
int Delta=10;
char FlToGSM=0;   // Признак того, что сотовый используется для вывода информации
char FlToUSART=0; // Признак того, что CОМ-порт используется для вывода информации
int Temp1P=987;     // Температура первой (недробной) перегонки 
int Temp2P=964;     // Температура второй  перегонки  (дистилляция без дефлегматора)
int Temp3P=954;     // Температура третьей перегонки  (дистилляция без дефлегматора)
int tEndRectRazgon=830;     // Температура окончания режима разгона 83.0 С
int PowerRect=1000;     // Мощность ректификации
int tStabSR;// Температура, относительно которой стабилизируется отбор СР
char ProcChimSR;// Текущий процент отбора СР
unsigned int SecTempPrev;// Знчение секудндомера, при котором было считана эта температура.
int TempPrev=0;// Время Предыдущей температуры (для сверки с текущей (проверка стабилизации значение 344 для облегчения отладки)

int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
unsigned int timeChimRectOtbGlv=2000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 20 секунд)
unsigned char ProcChimOtbGlv=5;  // Процент ШИМ отбора голов (в данном случае это 5 процентов)
unsigned int timeChimRectOtbSR=1000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
unsigned char tDeltaRect=10;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
unsigned int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
unsigned int tEndRect=995;       // Температура в кубе, при которой прекращается ректификация (в данном случе 99.5 С)
char StateRectif=0; // Состояние конечного автомата процесса ректификации


char flTest=0;
char FlUsart=0; // Признак того, что надо вывести информацию на СОМ-порт

char flNeedAnalyse=0; // Флаг того, что надо анализировать результат измерения температуры
char flStateProcess=0;
//char flNeedScanKbd=0; // Флаг того, что надо читать состояние клавиш 
char CountKeys;       // Переменная для защиты от дребезга
char CountState=0; // Флаг того, что сохраняем состояние процесса (каждое значение - это полсекунды)


#define MAX_KLP 5       // Количество клапанов, которыми надо управлять по ШИМ. 
#define PIN_KLP_BEG 22  // Начальный пин для управления клапанами 

#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
#define KLP_VODA 1      // Номер клапана для управления общей подачей воды в систему
#define KLP_DEFL 2      // Номер клапана для подачи воды в дейфлегматор
#define KLP_GLV_HVS  3       // Номер клапана отбора головных и хвостовых фракций
#define KLP_SR   4      // Номер клапана отбора ректификата

#define TEMP_KUB  0      // Номер датчика  термометра в кубе
#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой



OneWire  ds(10);  // on pin 10
#define MAX_DS1820 5
unsigned char ds1820_devices;                  // Количество датчиков ds18b20 
unsigned char ds1820_rom_codes[MAX_DS1820][9]; // Коды датчиков ds18b20
char ds1820_popr[MAX_DS1820];                  // Поправки к температуре датчиков


unsigned int KlOpen[MAX_KLP];  // Время закрытия клапанов (в полупериодах, то есть 100 - это примерно 1 секунда)
unsigned int KlClose[MAX_KLP];// Время открытия клапанов  (в полупериодах,то есть 100 - это примерно 1 секунда)
char KlState[MAX_KLP];         // Состояние клапанов (1 открыт - 0 закрыт) 
unsigned int  KlCount[MAX_KLP]; // Счетчик состояния клапанов
char KlSelect=0;  // Выбран режим прибавления - либо время открытия, либо время закрытия - это для ручного управления ШИМом, тестирования и прочего
char KlTek=0;     // Для отладки - режим какого клапана отображать на дисплее  - это для ручного управления ШИМом, тестирования и прочего .  

// Ну это понятно, это подключен LCDs
LiquidCrystal lcd(52,50, 48, 46, 44, 42);

int MaxVolts;
int MaxVoltsOut;
unsigned int SrVolts;     // Сумма значений напряжения
int SqVoltsCalibration;  // Среднеквадратичное для калибровки по вольметру
int CountSrVolts;        // Количество значений напряжения

int temps[MAX_DS1820];            // Температура датчиков  
unsigned char nPopr=0;                     // Текущий датчик, которому вносится поправка

#define PIN_TRIAC  11    // Управление симистором реализовано через PIN 11

int Counter1=0;
unsigned int Seconds;   // Текущее состояние времени с начала процесса;
unsigned int SecondsEnd;// Время окончания процесса 
char NeedDisplaying;
int result;
unsigned int CountTimer3=0;
unsigned int CompA3=16;      // Текущее значение для периодического вызова таймера 3.
unsigned char StateVolts=0;  // Состояние вычисление среднеквадратичного 
//0 - надо вычислить - запускается старт, 1 - вычисляется, 2 - вычислено, 3 - идет обработка рузультата
// 4 - Результат обработан, можно вычислять следующий
unsigned int index_input=0; // Текущий размер массива дла расчета среднеквадратичного

unsigned int SquareNapr;
char flFirstZero=1;
//unsigned int VoltsZr;
unsigned long TekPower;
unsigned int TimeOpenTriac=0;
unsigned int TimeOpenTriacFact=0;
unsigned int CountTrans=0;
unsigned int TicZero; // Количество тиков таймера от нуля до нуля.
unsigned int TicSqNapr; // Количество тиков таймера от нуля до нуля, на основании которого рассчитано среднеквадратичное
char FirstRun;
// Установка мощности (Пока в виде переменных)

int Power=3000;       // Номинальная мощность ТЭНов
int UstPower=500;     // Нужно получить мощность от регулятора

char flNeedTemp=0;    // Флаг того, что нужно читать температуру датчиков
char StepOut=0;       // Признак шага чтения температуры 0 - выдаем команду на запрос температуры
                      // 1 - читаем температуру


// Пины, на которых сидят кнопки
#define PIN_SELECT 53
#define PIN_RIGHT 51
#define PIN_LEFT 49
#define PIN_UP 45
#define PIN_DOWN 47

#define PRESS_SELECT digitalRead(PIN_SELECT)==0
#define PRESS_RIGHT  digitalRead(PIN_RIGHT)==0
#define PRESS_LEFT  digitalRead(PIN_LEFT)==0
#define PRESS_UP     digitalRead(PIN_UP)==0
#define PRESS_DOWN   digitalRead(PIN_DOWN)==0

#define NPG_UROVEN digitalRead(A3)==0

void setup() 
{
  unsigned char i;
  // set up the LCD's number of columns and rows: 
  Serial1.begin(9600);
  lcd.begin(16, 2);
  
  // Print a message to the LCD.
  //  lcd.print("hello, world!");
  analogReference(DEFAULT);
   
  // analogReference(INTERNAL2V56);

  pinMode(PIN_TRIAC, OUTPUT);
  digitalWrite(PIN_TRIAC, HIGH);  
  pinMode(29, OUTPUT);
  digitalWrite(29, HIGH);  
//  pinMode(22, OUTPUT);
//  digitalWrite(22, HIGH);  
//  pinMode(25, OUTPUT);
//  digitalWrite(25, HIGH);  
//  pinMode(26, OUTPUT);
//  digitalWrite(26, HIGH);  
//  pinMode(24, OUTPUT);
//  digitalWrite(24, HIGH);  
  pinMode(A3, INPUT);
  digitalWrite(A3, HIGH);  



  pinMode(PIN_SELECT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_SELECT, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_RIGHT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_RIGHT, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_LEFT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_LEFT, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_UP, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_UP, HIGH);       // включить подтягивающий резистор
  
  pinMode(PIN_DOWN, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_DOWN, HIGH);       // включить подтягивающий резистор
  
  
  // Проходим по клапанам и устанавливаем им ШИМ и настраиваем пины
  for(i=0;i<MAX_KLP;i++)
  {
    pinMode(PIN_KLP_BEG+i, OUTPUT);
    digitalWrite(PIN_KLP_BEG+i, LOW);  
    KlOpen[i]=2*(i+1);    // Два период открыт, шесть закрыт, это 
    KlClose[i]=6*(i+1);   // рассчитанный мной в первом приближении оптимальный режим работы клапана, когда он и не перегревается
                          // и дает 100% потока воды и не дает гидроударов в системе.  
                          // Значение управленпия клапанами даем разное (для тестирования)

    // Клапана зануляем                          
    KlOpen[i]=0;    
    KlClose[i]=10;   
    KlState[i]=0;          // Начальное состояние - клапан закрыт, счетчик 0
    KlCount[i]=0;  
  }
  
  attachInterrupt(1, zero_crosss_int, RISING);  // Устанавливаем на 1-е прерывание функцию (это pin 3) обработку от детектора нулюя сетевого напряжения
//  attachInterrupt(0, zero_crosss_trans, RISING);  // Устанавливаем на 0-е прерывание функцию (это pin 2) обработку от детектора нуля трансформатора.


  // Таймер 2 используется для подсчета числа секунд и, возможно, программного небыстрого ШИМа
  // Прерываение по этому таймеру будет вызываться 125 раз в секунду.
  // Timer/Counter 2 initialization
  // Clock source: System Clock
  // Clock value: 62,500 kHz
  // Mode: Normal top=0xFF
  // OC2A output: Disconnected
  // OC2B output: Disconnected
  TCCR2A=0x00;
  TCCR2B=0x07;
  TCNT2=0x00;
  OCR2A=0x7D;
  OCR2B=0x00;  
  //  // Timer/Counter 1 Interrupt(s) initialization
  TIMSK2=0x02;


  // Таймер 3 будет использоваться для такой, обычно очень несвойственной для него процедуры, как "замена" аппаратного прерывания АЦП.
  // (даже обидно для этих целей целый таймер задействовать!)
  // Timer/Counter 3 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC3A output: Discon.
  // OC3B output: Discon.
  // OC3C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer3 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR3A=0x00;
  TCCR3B=0x03;
  TCNT3H=0x00;
  TCNT3L=0x00;
  ICR3H=0x00;
  ICR3L=0x00;

  OCR3AH=0;
  OCR3AL=0x7;

  OCR3BH=0x00;
  OCR3BL=0x00;
  OCR3CH=0x00;
  OCR3CL=0x00;  
  // Timer/Counter 3 Interrupt(s) initialization
  TIMSK3=0x02;

  // Таймер 4 будет использоваться для подсчета числа тиков при вызове АЦП в расчете среднеквадратичного 
  // (поскольку непонятно, чего и сколько это занимает в Ардуино - исходный код разбирать неохота)
  // Timer/Counter 4 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC4A output: Discon.
  // OC4B output: Discon.
  // OC4C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer4 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: Off
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR4A=0x00;
  TCCR4B=0x03;
  TCNT4H=0x00;
  TCNT4L=0x00;
  ICR4H=0x00;
  ICR4L=0x00;
  OCR4AH=0x00;
  OCR4AL=0x00;
  OCR4BH=0x00;
  OCR4BL=0x00;
  OCR4CH=0x00;
  OCR4CL=0x00;
  // Timer/Counter 4 Interrupt(s) initialization
  TIMSK4=0x00;


  // Таймер 5 будет использоваться для управления симистором по прерыванию COMPA.
  // Timer/Counter 5 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC5A output: Discon.
  // OC5B output: Discon.
  // OC5C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer5 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR5A=0x00;
  TCCR5B=0x03;
  TCNT5H=0x00;
  TCNT5L=0x00;
  ICR5H=0x00;
  ICR5L=0x00;
  OCR5AH=0x00;
  OCR5AL=0x02;
  OCR5BH=0x00;
  OCR5BL=0x00;
  OCR5CH=0x00;
  OCR5CL=0x00;
  // Timer/Counter 5 Interrupt(s) initialization
  TIMSK5=0x02;


//  TekPower=(unsigned long) UstPower*220*220/ Power;
  StateVolts=0;
  
  ds1820_devices=0;
  while(ds.search(ds1820_rom_codes[ds1820_devices])) {
    ds1820_devices++;
  }
  ds.reset_search();
  lcd.clear();
  sprintf(lcd_buffer,"ds18B20Count=%u",ds1820_devices); //запись в буфер текста и значений температуры в подготовленном
  lcd.print(lcd_buffer);
  delay(2000);
  flNeedTemp=0;
  StepOut=0;
  for(i=0;i<ds1820_devices;i++)
  {
    temps[i]=0;
    ds1820_popr[i]=0;                  // Поправки к температуре датчиков устанавливаем в ноль (в дальнейшем они сами считаются из eeprom, если были ранее записаны).
  }
  
  // Читаем ранее сохраненные значения из энергонезависимой памяти.
  if (EEPROM.read(0)!=PR_REWRITE_EEPROM)
  { 
    writeEEPROM();
  }
  
  readEEPROM();
  
}

// Прерывание управления симистором.
ISR(TIMER5_COMPA_vect) 
{
  // Включаем симистор
  digitalWrite(PIN_TRIAC, HIGH);  
  // ждем 10 мкс и выключаем симистор
  delayMicroseconds(10);       
  digitalWrite(PIN_TRIAC, LOW);  
}

// Прерывание по таймеру 3 для расчета выборки для среднеквадратичного
ISR(TIMER3_COMPA_vect) 
{
  unsigned int zn;
  unsigned int tic;
//  CountTimer3++; // Это для отладки, чтобы понять, что таймер вызывается и я правильно понял логику таймеров в Ардуино.

  // Здесь проявляется недостаток реалициации АЦП в Ардуино, если даже на Atmega16 c частотой 8Мгц, АЦП, реализованное через аппаратное прерывание успевает стабильно отловить ноль в одном и том же месте
  // то здесь ноль отлавивается в  немного отличающихся местах, на пару десатков тиков таймера.
  // Если бы измерение сетевого напряжения проводилось от резисторного делителя, а не от транформатора, то 0 АЦП соответсвовал бы переходу через 0 контроллера детектора нуля, и было бы проще, а так 
  // надо как-то организовать дополнительно прерывание по 0 именно от напряжения трансформатора, или подумать, как решить это программно.
  
  // Если дана команда начать расчет среднеквадратичного, то читаем значение АЦП.
  if (StateVolts==0 || StateVolts==1)
  {
    
    // В фунции analogRead(), судя по всему, используется delay, что приводит к "помаргиванию" регулятора, если вызов этой функции попадает на детектор нуля или еще како-нибудь важное
    // прерывание. Надо бы в дальнейшем учесть это и вызывать analogRead() только в том случае, когда переход через ноль еще далеко. (более 40 тиков таймера)
    result=analogRead(2); // читаем показания с pin А3
  }

  tic=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера


  if (result==0)
  {

    // Если дана команда рассчитать среднеквадратичное, или среднеквадратичное рассчитывается, но 0 встретился раньше, чем положено, то запускаем расчет заново.        
    if (StateVolts==0 || (StateVolts==1 && index_input<=20))
    {
      index_input=0;
      StateVolts=1; 
      tic=0;  
      MaxVolts=0;
      TCNT4H=0x00;
      TCNT4L=0x00;

    }  

    // Если ноль встретился и процесс расчета идет, тогда ставим флаг окончания процесса.
    if (StateVolts==1 && index_input>59)
    {                
      data_adc[index_input]=result;    
      tic_adc[index_input]= tic;
      index_input++;
//      NeedDisplaying=true;
      StateVolts=2;     
      MaxVoltsOut=MaxVolts;
    }                 

  }

  // Если процесси идет, тогда просто накапливаем значения измерений
  if (StateVolts==1)
  {
    data_adc[index_input]=result;   
    tic_adc[index_input]=tic;
    index_input++;
    if (result>MaxVolts)
    {  
      MaxVolts=result;
    }
  }


  // Если превышен размер массива, то считаем эту выборку несостоятельной (Вдруг глюк АЦП или помеха в сети), начинаем снова.
  if (index_input>=MAX_INDEX_INPUT)  StateVolts=0;

  // Сбрасываем таймер
  TCNT3H=0x00;
  TCNT3L=0x00;
}


// Прерывание вызывается 125 раз в секунду
ISR(TIMER2_COMPA_vect) 
{

  ScanKbd();

//  flNeedScanKbd=1;

  // Следим за защитой от дребезга клавиш
  if (Counter1 % 20 ==0)
  {              
    if (CountKeys>0) CountKeys--;
  }

  if (Counter1==62)
  {
    NeedDisplaying=true;
  }

  if (Counter1 % 20 ==0)
  {
    if (StateVolts==4) 
    {
      StateVolts=0; // Раз в 1/5 секунды запускаем измерение среднеквадратичного (в дальнейшем можно будет настроить, 
                    // чтобы оно делалось так часто, насколько позволяют возможности контроллера).
    }
    
  }
  Counter1++;
  if (Counter1>=125)
  {

    if (CountState>0) 
    {   if (CountState==1) lcd.clear();
        CountState--;
    }
    Seconds++;
    Counter1=0;
    NeedDisplaying=true;
    
    // Если контроллер используется как термостат, или это уже чтение готового результата, то читаем раз в секунду.
    // Или мы сейчас вводим поправки.
    if (IspReg==2 || StepOut!=0 || FlState==300) 
    {
        flNeedTemp=1; // Устанавливаем флаг того, что надо читать температуру
     }
     else
     {
         // Иначе запускаем расчет один раз в 5 секунд (чтоб поменьше мограл регулятор мощности).
          if (Seconds % 5==0) flNeedTemp=1; 
     }
    
  }

  if (CountState<=0) 
   {
    FlState=0;
    CountState=0;
   }  
   
  // Сброс таймера
  TCNT2=0x00;
}


// Функция вызывается по прерыванию нуля от нуля сети 220 вольт
void zero_crosss_int()  // function to be fired at the zero crossing to dim the light
{
    unsigned char i;

    if (UstPower>=Power)
    {
      // Если мощность больше или равна номинальной, включаем триак всегда, при этом прерывание на закрытие никогда не выполнится.  
    TimeOpenTriac=5000;
      digitalWrite(PIN_TRIAC, HIGH);  
    }
    
    TicZero=(int) TCNT5L | (int) (TCNT5H<<8); // Расчитывааем текущее значение таймера
    // Сбрасываем 5-й таймер.
    TCNT5H=0x00;
    TCNT5L=0x00;
    
    TimeOpenTriacFact=(unsigned long) TimeOpenTriac * TicZero / TicSqNapr;
    
//    TimeOpenTriacFact=TimeOpenTriac;
    //TimeOpenTriac=2000;
    // В прерывании нуля настраиваем, чтобы прерывание на 5-м таймере выдалось через то время, которое мы ранее рассчитали.
    OCR5AH=(char)(TimeOpenTriacFact>>8);
    OCR5AL=(char)TimeOpenTriacFact;
    
    
    // В прерывании нуля управляем открытием клапанов (а их лучше открывать по 0, чтобы не было помех)
    for (i=0;i<MAX_KLP;i++)
    {
        KlCount[i]++;
        if (KlState[i]==0)
        {
            if (KlCount[i]>KlOpen[i])
                {       
                    KlState[i]=1;
                    KlCount[i]=0;
                }
            else
            {
                digitalWrite(PIN_KLP_BEG+i, HIGH);  
            } 
            
        }                     
        else
        {
            if (KlCount[i]>=KlClose[i])
                {
                    KlState[i]=0;
                    KlCount[i]=0;
                }
            else
            {
                digitalWrite(PIN_KLP_BEG+i, LOW);  
            } 
        }
    
    }
    
    
}

// Функция вызывается по прерыванию нуля от трансформатора (из-за сдвига фазы от нуля она вызывается не в то же время, что и прерывание от нуля 220 вольт)
// Пока это прерывание не используется и наверное нужно не будет
void zero_crosss_trans()  
{   int tic;

   CountTrans++;  
//  // Встретили прерывание нуля
//    // Если необходимо рассчитать средннее или оно уже рассчитано было
//    if (StateVolts==1)
//    {  // Если среднее накапливается в данный момент, то это означет, что оно уже рассчитано.
//      if (index_input>=10)
//      { 
//        // 
//        if (data_adc[index_input-1]!=0)
//        {
//          tic=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера
//          data_adc[index_input]=0;  
//          tic_adc[index_input]= tic;
//          index_input++;
//          MaxVoltsOut=MaxVolts;
//        }
//        StateVolts=2;
//      }
//      else
//      StateVolts=0;
//    }
//    
//    if (StateVolts==0)
//    {
//        index_input=0;
//        data_adc[index_input]=0;  
//        TCNT4H=0x00;
//        TCNT4L=0x00;
//        tic_adc[index_input]=0;
//        StateVolts=1; 
//        MaxVolts=0;
//        SrVolts=0;
//        CountSrVolts=0;
//        index_input++;
//    }
}


void DisplayData()
{
  int tic1;
  char MaxPage=1;
  unsigned char hour,minute,second;
  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  second=tic1 % 60;   

  if (FlState==0) 
    lcd.setCursor(0, 0);
  else 
    lcd.clear();  //очистка дисплея   
  

    switch (FlState)
    {
        case 0:
            
            switch (IspReg)
            {
                case 101: // Displaying
                    //sprintf(lcd_buffer,"S=%5u TT=%5u",Seconds,MaxTimeTimer); //запись в буфер текста и значений температуры в подготовленном
                    
                    //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
                    //  это напряжение нужно для калибровки нашего измерителя
                    
                    if (DispPage==0) 
                    {
                      sprintf(lcd_buffer,"%02u:%02u:%02u DSP 1/2",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                      lcd.print(lcd_buffer);
                      sprintf(lcd_buffer,"Zr=%4u U=%3u",TimeOpenTriac,(long) MaxVoltsOut*707/1000); //запись в буфер текста и значений температуры в подготовленном
                    }
                    
                    if (DispPage==1) 
                    {
                      sprintf(lcd_buffer,"D2/2 T=%3u, %3u ",temps[0],temps[1]); //запись в буфер текста и значений температуры в подготовленном
                      lcd.print(lcd_buffer);
                      sprintf(lcd_buffer,"%3u,%3u,%3u,%4u",temps[2],temps[3],temps[4],analogRead(A7)); //запись в буфер текста и значений температуры в подготовленном
                    }
                    lcd.setCursor(0, 1);
                    lcd.print(lcd_buffer);                      

                    break;
                case 102: // Термостат         
                    sprintf(lcd_buffer,"%02u:%02u:%02u TS(%i)",hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"t=%5i/%5i /%i",temps[0],TempMax,flStateProcess); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 103: // Регулятор мощности
                    sprintf(lcd_buffer,"%02u:%02u:%02u RMU=%3u",hour,minute,second,(long) MaxVoltsOut*707/1000); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"P=%4u/%4u",UstPower,Power); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 104: // Перевый (недробный) отбор
                    sprintf(lcd_buffer,"%02u:%02u:%02u 1-Otbor",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"t=%5i/%5i /%i",temps[0],TempMax,flStateProcess); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 105: // Отбор голов
                    sprintf(lcd_buffer,"%02u:%02u:%02u  Otb GLV",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"Pow=%4u U=%u",UstPower,MaxVolts); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 106: // Второй дробный отбор
                    sprintf(lcd_buffer,"%02u:%02u:%02u 2-Otbor",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"t=%5i/%5i ",temps[0],TempMax); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 107: // Третий дробный отбор
                    sprintf(lcd_buffer,"%02u:%02u:%02u 3-Otbor",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"t=%5i/%5i ",temps[0],TempMax); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 108: // Разваривание
                    sprintf(lcd_buffer,"%02u:%02u:%02u Razvar",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"Razvarivan"); //запись в буфер текста и значений температуры в подготовленном
                    break;
                case 109: // Ректификация
                    if (DispPage==0) 
                    {
                      switch (StateRectif)
                      { 
                        case 0: //Не запущено
                          sprintf(lcd_buffer,"%02u:%02u:%02u Rect",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i P=%4i",temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 2: //Разгон
                          sprintf(lcd_buffer,"%02u:%02u:%02u R RZG",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 3: //Стабилицация колонны
                          sprintf(lcd_buffer,"%02u:%02u:%02u R NSB",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tN=%3i(%2i) %4uW",temps[TEMP_RK20],Seconds-SecTempPrev,UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 4: //Отбор голов
                          sprintf(lcd_buffer,"%02u:%02u:%02u R GLV",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i %4uW",temps[TEMP_KUB],tEndRectOtbGlv,UstPower); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 5: //Стоп, ожидание возврата температуры
                          sprintf(lcd_buffer,"%02u:%02u:%02u R Stop ",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tN=%3i/%3i %2i%%",temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 6: //Ректификация
                          sprintf(lcd_buffer,"%02u:%02u:%02u RSt %2i%%",hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tN=%3i/%3i/d%2i ",temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 7: //Отбор хвостов
                          sprintf(lcd_buffer,"%02u:%02u:%02u R Hvost",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i    ",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 8: //Отбор ожидание 3 минут
                          sprintf(lcd_buffer,"%02u:%02u:%02u R Wait ",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i ",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                        case 100: //Окончание
                          sprintf(lcd_buffer,"%02u:%02u:%02u Rec End",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                          lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                          sprintf(lcd_buffer,"tK=%3i/%3i ",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
                          break;
                      }
                    }
                    else
                    {
                      // На второй странице всегда показываем температуру датчиков
                      sprintf(lcd_buffer,"D2/2 T=%3u, %3u ",temps[0],temps[1]); //запись в буфер текста и значений температуры в подготовленном
                      lcd.print(lcd_buffer);
                      sprintf(lcd_buffer,"%3u, %3u, s%3u",temps[2],temps[3],Seconds-SecTempPrev); //запись в буфер текста и значений температуры в подготовленном
                    }
                    break;
                case 130: // Резерв
                    sprintf(lcd_buffer,"%02u:%02u:%02u Reserv",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                    //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                    lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
                    sprintf(lcd_buffer,"KLP %3i %3i /%1i",KlOpen[KlTek],KlClose[KlTek],KlTek); //запись в буфер текста и значений температуры в подготовленном
                    break;
            }   
            // Это обычное состояние
//
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 100:
            sprintf(lcd_buffer,"UstParam",FlState); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 101:
            sprintf(lcd_buffer,"IsR = Displaying"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 102:
            sprintf(lcd_buffer,"IsR = Termostat"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 103:
            sprintf(lcd_buffer,"IsR = Reg Power"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 104:
            sprintf(lcd_buffer,"IsR = 1 ND otbor"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 105:
            sprintf(lcd_buffer,"IsR = otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 106:
            sprintf(lcd_buffer,"IsR = 2 DR otbor"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 107:
            sprintf(lcd_buffer,"IsR = 3 DR otbor"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 108:
            sprintf(lcd_buffer,"IsR = Razvar"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Zerno",PowerRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 109:
            sprintf(lcd_buffer,"IsR = Rectif"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 130:
            sprintf(lcd_buffer,"IsR = Reserv"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"(%i)",FlState); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 200:
            sprintf(lcd_buffer,"Max_t_Tst=%5i",TempTerm); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 201:
            sprintf(lcd_buffer,"Power TEN=%5u",Power); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 202:
            sprintf(lcd_buffer,"Power Reg=%5u",UstPower); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 203:
            sprintf(lcd_buffer,"ParamUSART=%u",FlToUSART); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 204:
            sprintf(lcd_buffer,"ParamGSM=%u",FlToGSM); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 205:
            sprintf(lcd_buffer,"dtTermostat=%3i",Delta); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 206:
            sprintf(lcd_buffer,"Temp 1 Nedrobn"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i   ",Temp1P); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 207:
            sprintf(lcd_buffer,"Temp 2 Drobn"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i",Temp2P); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 208:
            sprintf(lcd_buffer,"Temp 3 Drobn"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Distill=%3i",Temp3P); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 209:
            sprintf(lcd_buffer,"Temp Okon Razgon"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",tEndRectRazgon); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 210:
            sprintf(lcd_buffer,"Power"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",PowerRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 211:
            sprintf(lcd_buffer,"Vvod Popravok"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"ds18b20 "); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 212:
            sprintf(lcd_buffer,"Temp Okon Otbor"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Glv Rectif=%3i",tEndRectOtbGlv ); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 213:
            sprintf(lcd_buffer,"CHIM Otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%5i",timeChimRectOtbGlv); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 214:
            sprintf(lcd_buffer,"%% CHIM Otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",ProcChimOtbGlv); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 215:
            sprintf(lcd_buffer,"CHIM Otbor SR"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%5i",timeChimRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 216:
            sprintf(lcd_buffer,"Delta Otbor SR"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3u",tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 217:
            sprintf(lcd_buffer,"Temp Okon Otbor"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"SR Rectif=%3i",tEndRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 218:
            sprintf(lcd_buffer,"Temp Okon"); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Rectif=%3i",tEndRect); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        case 300:
            sprintf(lcd_buffer,"Temp%1i=%3u",nPopr,temps[nPopr]); //запись в буфер текста и значений температуры в подготовленном
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf(lcd_buffer,"Popr=%3i T=%3u",ds1820_popr[nPopr], (temps[nPopr]+ds1820_popr[nPopr])); //запись в буфер текста и значений температуры в подготовленном
            lcd.setCursor(0, 1);
            lcd.print(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        default:
        break;
    }

//    
//  lcd.setCursor(0, 0);
//  lcd.print(Seconds);
//  lcd.setCursor(5, 0);
//  lcd.print(MaxVoltsOut);
//  lcd.setCursor(9, 0);
//  lcd.print((long)MaxVoltsOut*707/1000);
//  lcd.setCursor(0, 1);
//  lcd.print(index_input);
//  lcd.setCursor(5, 1);
//  lcd.print(TimeOpenTriac);
//  NeedDisplaying=false;
//  lcd.setCursor(10, 1);
//  lcd.print(TicZero);

  NeedDisplaying=false;
 
}

void writeEEPROM()
{ int i; 
  ee_addr=0;
  eeWriteChar(PR_REWRITE_EEPROM);
  eeWriteChar(IspReg);
  eeWriteInt(Power);
  eeWriteInt(UstPower);
  eeWriteInt(TempTerm);
  eeWriteInt(Delta);
  eeWriteChar(FlToUSART);
  eeWriteChar(FlToGSM);
  eeWriteInt(Temp1P);
  eeWriteInt(Temp2P);
  eeWriteInt(Temp3P);
  for(i=0;i<MAX_DS1820;i++)
    eeWriteChar(ds1820_popr[i]);
    
  eeWriteInt(tEndRectRazgon);
  eeWriteInt(PowerRect);
  
  eeWriteInt(tEndRectOtbGlv);
  eeWriteInt(timeChimRectOtbGlv);
  eeWriteChar(ProcChimOtbGlv);
  eeWriteInt(timeChimRectOtbSR);
  eeWriteChar(tDeltaRect);
  eeWriteInt(tEndRectOtbSR);
  eeWriteInt(tEndRect);

  //TekPower=(unsigned long) UstPower*220*220/ Power;
}

void readEEPROM()
{
  int i; 
  ee_addr=0;
  eeReadChar();
  IspReg=eeReadChar();
  Power=eeReadInt();
  UstPower=eeReadInt();
  TempTerm=eeReadInt();
  Delta=eeReadInt();
  FlToUSART=eeReadChar();
  FlToGSM=eeReadChar();
  Temp1P=eeReadInt();
  Temp2P=eeReadInt();
  Temp3P=eeReadInt();
  for(i=0;i<MAX_DS1820;i++)
    ds1820_popr[i]=eeReadChar();
  tEndRectRazgon=eeReadInt();
  PowerRect=eeReadInt();
  
  tEndRectOtbGlv=eeReadInt();
  timeChimRectOtbGlv=eeReadInt();
  ProcChimOtbGlv=eeReadChar();
  timeChimRectOtbSR=eeReadInt();
  tDeltaRect=eeReadChar();
  tEndRectOtbSR=eeReadInt();
  tEndRect=eeReadInt();
    
  //TekPower=(unsigned long) UstPower*220*220/ Power;
}


void ScanKbd()
{
   char i;
   // Если режим защиты от дребезга уже выключен
   if (CountKeys==0)
   {
//        if (PINB.0==0 && PINA.1==0)
//        {
//            Seconds=0;
//            CountKeys=6;     
//            for(i=0;i<4;i++)
//            {
//                KlState[i]=0;
//                KlCount[i]=0;
//            }
//            DisplayData();
//            return;            
//        }
        
//        if (PINA.2==0 && PINB.1==0)
//        {                
//            KlTek++;
//            if (KlTek>2) KlTek=0;
//            CountKeys=12;
//            DisplayData();
//            FlAnIsp=0;
//            return;            
//        }
            
            
        if (PRESS_LEFT && PRESS_RIGHT)
        {
            lcd.begin(16, 2);
        }
        

        // Нажатие кнопок одновременно ввехр и вниз позволяет перейти к следующему этапу (отладочные кнопки)
        if (PRESS_UP && PRESS_DOWN)
        {
          StateRectif++; // Состояние конечного автомата процесса ректификации
          CountKeys=10; // Большая защита от дребезга, чтоб случайно не нажали.

        }
    
        if (PRESS_SELECT)
        {            
//            if (IspReg==9)
//            {  if (FlAnIsp==0)
//                { CountKeys=2;
//                  FlAnIsp=1;
//                  return;
//                }
//               
//            }               
//            FlAnIsp=0;
             switch (FlState)
             {         
                case 0:   
                
                    FlState=IspReg;
                    break;
                case 100:
                    FlState=200;      
                    break;   
                case 101:
                    FlState=0;      
                    IspReg=101;   
                    writeEEPROM();
                    break;   
                case 102:
                    IspReg=102;
                    writeEEPROM();
                    FlState=200;
                    break;    
                case 200:
                    FlState=0;
                    writeEEPROM();
                    TempMax=TempTerm;
                    break;    
                case 103:
                    IspReg=103;
                    writeEEPROM();
                    FlState=202;
                    break;    
                case 201:
                    writeEEPROM();
                    FlState=0;
                    break;     
                case 202:
                    writeEEPROM();
                    FlState=0;
                    break;     
                case 104:
                    IspReg=104;
                    TempMax=Temp1P;
                    writeEEPROM(); 
                    FlState=206;
                    break;     
                case 105:  
                    IspReg=105;
                    writeEEPROM();
                    FlState=0;
                    break;     
                case 106:
                    IspReg=106;
                    TempMax=Temp2P;
                    writeEEPROM(); 
                    FlState=207;
                    break;     
                case 107:
                    IspReg=107;
                    TempMax=Temp3P; 
                    writeEEPROM();
                    FlState=208;
                    break;     
                case 108:
                    IspReg=108;
                    FlState=0;
                    writeEEPROM();
                    break;
                case 109:
                    IspReg=109;
                    FlState=209;
                    writeEEPROM();
                    break;
                case 130:
                    FlState=130;
                    break;     
                case 203:       
                case 204:       
                case 205:       
                case 206:       
                case 207:       
                case 208:       
                case 209:       
                case 210:       
                case 212:       
                case 213:       
                case 214:       
                case 215:       
                case 216:       
                case 217:       
                case 218:       
                    writeEEPROM();
                    FlState=0;
                    break;    
                case 211:
                    // Вызываем чтение температуры принудительно
                    FlState=300;
                    break;     
                case 300:       
                    writeEEPROM();
                    FlState=211;
                    break;    
             }                            
              DisplayData();
              CountState=4;
              if (CountKeys==0) CountKeys=6;              
                           
        }

        // Вторая  кнопка ( кнопка -)        
        if (PRESS_RIGHT)  
        { 
         switch (FlState)
         {                                              
            case 0:           
              if (DispPage<1) DispPage++;
              CountKeys=4;              
              break;
            case 100:
            case 101:
            case 102:
            case 103:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
                FlState++;    
                break;   
            case 109:
                FlState=130;    
                break;   
            case 130:
                FlState=100;
                break;
            case 200:   
            case 201:
            case 202:
            case 203:
            case 204:
            case 205:
            case 206:
            case 207:
            case 208:
            case 209:
            case 210:
            case 211:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
                FlState++;
                break;
            case 218:
                FlState=200;
                break;
            case 300:
                if (nPopr<MAX_DS1820-1) nPopr++;
                break;
          }
          
          //NeedDisplaying=1;
          DisplayData();
          if (CountKeys==0) CountKeys=6;
            
          CountState=4;
          
               
        }               
                         
        // первая  кнопка  (кнопка +)      
        
        if (PRESS_LEFT)
        { 
         switch (FlState)
         {

            case 0:          
              if (DispPage>0) DispPage--;
              CountKeys=4;              
              break;
            case 100:
                FlState=130;   
                break;
            case 101:
            case 102:
            case 103:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
                FlState--;   
                break;
            case 130:
                FlState=109;   
                break;
                
            case 201:   
            case 202:
            case 203:
            case 204: 
            case 205: 
            case 206: 
            case 207: 
            case 208: 
            case 209: 
            case 210: 
            case 211: 
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
               FlState--;
               break;
            case 200:
                FlState=218;
                break;     
            case 300:
                if (nPopr>0) nPopr--;
                break;
         }         
                 
          //NeedDisplaying=1;
          DisplayData();
          CountState=4;
          if (CountKeys==0) CountKeys=6;
        }
        


        if (PRESS_UP)  
        { 
         CountState=0;
         switch (FlState)
         {                                              
            case 0:
              // В сотоянии 0 обработка клавиш происходит за выходом модели этого конечного автомата.

             // Ректификация
             if (IspReg==109)
             {
                switch(StateRectif)
                {
                  case 2:
                    tEndRectRazgon++;
                    break;
                  case 3:
                    PowerRect+=5;
                    CountKeys=2;
                    break;
                  case 4:
                    tEndRectOtbGlv++;
                    break;
                  case 5:
                    tStabSR++;
                    break;
                  case 6:
                    ProcChimSR++;
                    break;
                  case 7:
                    tEndRect++;
                    break;
                }
             }
             
             // Регулятор мощности
             if (IspReg==103)
             {
                UstPower+=5;
                //TekPower=(unsigned long) UstPower*220*220/ Power;
                CountKeys=2;
             }
             break; 
              
            case 200:
               TempTerm++;
               CountKeys=2;
               break;
            case 201:
               Power+=10;
               CountKeys=2;
               break;
            case 202:
                UstPower+=10;
                CountKeys=2;
                break;
            case 203:
                FlToUSART=1;
                break;
            case 204:   
                FlToGSM=1;
                break;                     
            case 205:   
                Delta++;
                CountKeys=2;
                break;                     
            case 206:   
                Temp1P++;
                CountKeys=2;
                break;                     
            case 207:   
                Temp2P++;
                CountKeys=2;
                break;                     
            case 208:   
                Temp3P++;
                CountKeys=2;
                break;                     
            case 209:   
                if (tEndRectRazgon<920)
                          tEndRectRazgon++;
                CountKeys=2;
                break;                     
            case 210:   
                PowerRect+=10;
                CountKeys=2;
                break;                     
            case 212:
                tEndRectOtbGlv++;
                CountKeys=2;
                break;                     
            case 213:
                timeChimRectOtbGlv+=10;
                CountKeys=2;
                break;
            case 214:
                ProcChimOtbGlv++;
                CountKeys=4;
                break;
            case 215:
                timeChimRectOtbSR+=10;
                CountKeys=2;
                break;
            case 216:
                tDeltaRect++;
                CountKeys=4;
                break;
            case 217:
                tEndRectOtbSR++;
                CountKeys=2;
                break;
            case 218:
                tEndRect++;
                CountKeys=2;
                break;
            case 300:   
                ds1820_popr[nPopr]++;
                CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
                CountKeys=4;
                break;                     
         }         
                 
          //NeedDisplaying=1;
          DisplayData();
          if (CountState==0) CountState=4;
          if (CountKeys==0) CountKeys=6;
       }
       

      if (PRESS_DOWN)  
      { 
       CountState=0;
       switch (FlState)
         {                                              
            case 0:
              // В сотоянии 0 обработка клавиш происходит за выходом модели этого конечного автомата.

             // Ректификация
             if (IspReg==109)
             {
                switch(StateRectif)
                {
                  case 2:
                    tEndRectRazgon--;
                    break;
                  case 3:
                    PowerRect-=5;
                    CountKeys=2;
                    break;
                  case 4:
                    tEndRectOtbGlv--;
                    break;
                  case 5:
                    tStabSR--;
                    break;
                  case 6:
                    ProcChimSR--;
                    break;
                  case 7:
                    tEndRect--;
                    break;
                }
             }
             
             // Регулятор мощности
             if (IspReg==103)
             {
                UstPower+=5;
                //TekPower=(unsigned long) UstPower*220*220/ Power;
                CountKeys=2;
             }
             break; 
             
            case 200:
               TempTerm--;
               CountKeys=2;
               break;
            case 201:
               Power-=10;
               CountKeys=2;
               break;
            case 202:
                UstPower-=10;
                CountKeys=2;
                break;
            case 203:
                FlToUSART=0;
                break;
            case 204:   
                FlToGSM=0;
                break;                     
            case 205:   
                Delta--;
                CountKeys=2;
                break;                     
            case 206:   
                Temp1P--;
                CountKeys=2;
                break;                     
            case 207:   
                Temp2P--;
                CountKeys=2;
                break;                     
            case 208:   
                Temp3P--;
                CountKeys=2;
                break;                     
            case 209:   
                if (tEndRectRazgon>800)
                            tEndRectRazgon--;
                CountKeys=2;
                break;                     
            case 210:   
                PowerRect-=10;
                CountKeys=2;
                break;                     
            case 212:
                tEndRectOtbGlv--;
                CountKeys=2;
                break;                     
            case 213:
                timeChimRectOtbGlv-=10;
                CountKeys=2;
                break;
            case 214:
                ProcChimOtbGlv--;
                CountKeys=4;
                break;
            case 215:
                timeChimRectOtbSR-=10;
                CountKeys=2;
                break;
            case 216:
                tDeltaRect--;
                CountKeys=4;
                break;
            case 217:
                tEndRectOtbSR--;
                CountKeys=2;
                break;
            case 218:
                tEndRect--;
                CountKeys=2;
                break;
            case 300:   
                ds1820_popr[nPopr]--;
                CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
                CountKeys=4;
                break;                     
         }         
               
        //NeedDisplaying=1;
        DisplayData();
        if (CountState==0) CountState=4;
        if (CountKeys==0) CountKeys=6;
      }
   }
}



void ProcessRectif()
{

//#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
//#define KLP_VODA 1      // Номер клапана для управления общей подачей воды в систему
//#define KLP_DEFL 2      // Номер клапана для подачи воды в дейфлегматор
//#define KLP_GLV_HVS  3       // Номер клапана отбора головных и хвостовых фракций
//#define KLP_SR   4      // Номер клапана отбора ректификата
#define TEMP_KUB  0      // Номер датчика  термометра в кубе
#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой

  

  switch  (StateRectif)
  {
    case 0: // Процесс не запущен
      break;
    case 1: // Начало процесса
          KlOpen[KLP_VODA]=2;
          KlClose[KLP_VODA]=6;
          StateRectif=2;
    case 2: // Разгон
      UstPower=Power; // Устанавливаем максимальную мощность для разгона
      
     if (temps[TEMP_KUB]<tEndRectRazgon) break;
     
     // Подаем питание на клапан дефлегматора
      KlOpen[KLP_DEFL]=2;
      KlClose[KLP_DEFL]=6;
      TempPrev=temps[TEMP_RK20];
      SecTempPrev=Seconds; // Запоминаем дату последнего изменения температуры
      StateRectif=3;        
    case 3:// Стабилизация температуры
      UstPower=PowerRect;
      if (temps[TEMP_RK20]>700) // Если температура больше 70 градусов (вдруг куб прогрелся, а колонна еще нет, нелогично, конечно, но на всякий случай учтем)
      {
        if (abs(temps[TEMP_RK20]-TempPrev)<2) //Если текущая температура колонны равна температуре, запомненной ранее за исключением погрешности 0,2 градуса
        {
          if (Seconds-SecTempPrev>60) //Если с момента последнего измерения прошло более 60 секунд, тогда считаем, что температура в колоенне стабилизировалась
           {
             // Переходим к следующему этапу - отбору голов. 
              StateRectif=4;        
           }
          else
            break;
            
        }
        else
        {
           TempPrev=temps[TEMP_RK20];// Запоминаем температуру
           SecTempPrev=Seconds; // Запоминаем время последнего изменения температуры
           break;
        }
      }
      else
       break;
   case 4: // Отбор голов
      UstPower=PowerRect;
      
      
      //unsigned int timeChimRectOtbGlv=2000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 20 секунд)
      //unsigned char ProcChimOtbGlv=5;  // Процент ШИМ отбора голов (в данном случае это 5 процентов)
      // Устанавливаем клапан отбора хвостов и голов в соответвии с установленнным ШИМ
      //int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
      KlOpen[KLP_GLV_HVS]=((timeChimRectOtbGlv/10)*ProcChimOtbGlv)/10;
      KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
      if (temps[TEMP_KUB]<tEndRectOtbGlv)
      {  // Пока температура в кубе не выросла выше окончания отбора голов, продолжаем это состояни
        break;       
      }
      // Если температура превысила указанный рубеж, то переходим в состояние отбора спирта-ректификата.
      // Клапан отбора голов и хвостов отключаем
      tStabSR=temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор
      KlOpen[KLP_GLV_HVS]=0;
      KlClose[KLP_GLV_HVS]=10;
      ProcChimSR=90;
      StateRectif=5;        
   case 5: // Ожидание, пока температура не вернется к состоянию стабилизации
      // Это для отладки страт-стопа, на самом деле температура 28,5 градуса в этом режиме в колонне быть не может
      if (tStabSR==0) tStabSR=285;
      
      KlOpen[KLP_SR]=0;
      KlClose[KLP_SR]=10;
      if (temps[TEMP_RK20]>tStabSR)
      {
        break;
      }
      SecTempPrev=Seconds;// Запомним время, когда стабилизировалась температура
      StateRectif=6;        
   case 6: // Отбор СР
    //unsigned int timeChimRectOtbSR=1000;  // Шим отбора СР (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
    //unsigned char tDeltaRect=10;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
    //unsigned int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
    // Устанавливаем ШИМ отбора СР
      KlOpen[KLP_SR]=((timeChimRectOtbSR/10)*ProcChimSR)/10;
      KlClose[KLP_SR]=timeChimRectOtbSR-KlOpen[KLP_SR];
      if (temps[TEMP_RK20]>tStabSR+tDeltaRect) // Если текущая температура превысила базовую 
      {
        //Если температура превысилась менее, чем за одну минуту
        if (Seconds-SecTempPrev<60)
          {
            ProcChimSR-=10; // Тогда уменьшаем ШИМ на 10 
          }
          
        if (Seconds-SecTempPrev>600) // Если стабилизировалось более, чем за 10 минут, тогда прибавляем ШИМ на 5%
          {
            ProcChimSR+=5; // Тогда увеличиваем ШИМ на 5%
          }
         StateRectif=5;        
      }
      else // Если температура не выросла более, чем за 10 минут, прибавим ШИМ на 5%
      {
        if (Seconds-SecTempPrev>720) // Если не стабилизировалось более, чем за 12 минут, тогда прибавляем ШИМ на 5%
          {
            ProcChimSR+=5; // Тогда увеличиваем ШИМ на 5%
            SecTempPrev=Seconds;// Запомним время, когда стабилизировалась температура
          }
      }

      // Если температура в кубе превысила температуру при которой надо отбирать СР
      if (temps[TEMP_KUB]>=tEndRectOtbSR)
      {  
         StateRectif=7;        
         KlOpen[KLP_SR]=0;// Отключаем клапана отбора СР
         KlClose[KLP_SR]=10;
      }
      else    
        break;    
   case 7: // Отбор Хвостов
      KlOpen[KLP_GLV_HVS]=((timeChimRectOtbGlv/10)*90)/10;
      KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
      if (temps[TEMP_KUB]>=tEndRect)
      {  
          KlOpen[KLP_GLV_HVS]=0;  // Отключаем клапана отбора хвостов
          KlClose[KLP_GLV_HVS]=10;
          UstPower=0;
          StateRectif=8;        
          SecTempPrev=Seconds;// Запомним время, когда закончилась ректификация
      }
      else    
        break;    
   case 8:// Ждем три минуты для окончания подачи воды
     if  (Seconds-SecTempPrev>180)
     {
       // Отключаем на всякий случай все!
          KlOpen[KLP_GLV_HVS]=0;  // Отключаем клапана отбора хвостов
          KlClose[KLP_GLV_HVS]=10;
          KlOpen[KLP_SR]=0;  // Отключаем клапана отбора СР
          KlClose[KLP_SR]=10;
          KlOpen[KLP_VODA]=0;  // Отключаем клапана отбора Воды
          KlClose[KLP_VODA]=10;
          KlOpen[KLP_DEFL]=0;  // Отключаем клапана Дефлегматора
          KlClose[KLP_DEFL]=10;
          // Переводим автомат в конечное состояние
          StateRectif=100;        
          SecondsEnd=Seconds;
     }
    break;
   case 100:// Конечное состояние автомата
    break;
  }
  
}

void loop() 
{
  int i,j;
  unsigned long SqNapr=0,SqNaprPrev=0,FindPower;
  unsigned int TimeOpenTriac1=0;
  byte data[12];
  byte present = 0;
  unsigned int raw;
  byte ds18b20CRC;
  static int PowerPrev=0;
  static int UstPowerPrev=0;

  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  // print the number of seconds since reset:
  // Если есть необходимость произвести отображение информации на дисплее и среднеквадратичное уже рассчитано.
  if (NeedDisplaying && StateVolts!=0)
  {
    DisplayData();
  }
  

//  if (flNeedScanKbd==1)
//  {
//    flNeedScanKbd=0;
//  }

  if (StateVolts!=1)                 
  {
    if (flNeedTemp==1)
    {
        if (StepOut==0)
        {
          ds.reset();
          ds.write(0xCC,1);         // start conversion, with parasite power on at the end
          ds.write(0x44,1);         // start conversion, with parasite power on at the end
          flNeedTemp=0;
          StepOut=1;
        }
        else
        {
          for (j=0;j<ds1820_devices;j++)
          {
            present=ds.reset();
            
            #ifdef TIMING
              TCNT4H=0x00;
              TCNT4L=0x00;
            #endif            
              
          // Здесь вообще засада, передача кода датчика занимает около 1600 тиков таймера, что гарантирует пропуск регуляции как минимум одного полупериода.
          // Возможно решение - посадить каждый датчик на отдельный ПИН, тогда код датчика передавать не нужно.
           ds.select(ds1820_rom_codes[j]);    
              
            #ifdef TIMING
              unsigned int Tic2=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера
              sprintf(my_rx_buffer,"TicDs18Select=%i",Tic2);
              FlUsart=1;
            #endif
            
            ds.write(0xBE);         // Read Scratchpad
  //          Serial1.print(present,HEX);
  //          Serial1.print(" ");
            //        Читаем пока только 2 байта из 9, остальные не трогаем.
            for ( i = 0; i < 9; i++) 
            {  
              data[i] = ds.read();
  //            Serial1.print(data[i], HEX);
  //            Serial1.print(" ");
            }
  //          Serial1.print(" CRC=");
            ds18b20CRC=OneWire::crc8(data, 8);
            if (ds18b20CRC!=data[8])
            {
                //  Ошибка чтения, возможно в дальнейшем надо перечитать.
                
            }
            
            raw = (data[1] << 8) | data[0];          
            temps[j]=raw*5/8;
            
            // Если мы сейчас не находимся в режиме ввода поправок к датчикам, то прибавляем к температуре значение поправки
            
            if (FlState!=300)
            {

              temps[j]=temps[j]+(int) ds1820_popr[j];
              
               #ifdef TEST
//                   sprintf(my_rx_buffer,"Temp(%1i)=%i ishod=%i popr=%i FlSt=%i",j,temps[j],raw*5/8,ds1820_popr[j],FlState);
//                   FlUsart=1;
               #endif
              
              
            }
  //          Serial1.print(OneWire::crc8(data, 8), HEX);
  //          Serial1.println();
  //          
  //          Serial1.print(j);
  //          Serial1.print(" ");
  //          Serial1.print(temps[j]);
  //          
  //          Serial1.println();          
            
  //          temps[j] = temps[j] *5 / 8;
            StepOut=0;
            flNeedAnalyse=1;   // Все необходимые данные прочитаны устанавливаем флаг того, что нужно анализировать состояние выполнения процесса.
          } 
   
        }
        
    }
  }
  
  // Выполняем процесс.
  if (flNeedAnalyse==1)
  {
      switch(IspReg)
      {
        case 109: //Текущее состояние - ректификация
        
          if (StateRectif==0) // Если состояние ректификации - не запущено
          {
            Seconds=0;
            StateRectif=1; // Переводим процесс ректификации в состояние выполнения
          }
          ProcessRectif();
      }
      
    
  }
  
  

  if (FlUsart==1)
  {
      Serial1.println(my_rx_buffer);
      FlUsart=0;    
  }       
  
  // Сработка датчика уровня НПГ
  if (NPG_UROVEN)
  {
    KlOpen[KLP_NPG]=1;
    KlClose[KLP_NPG]=1;
  }  
  else
  {
    KlOpen[KLP_NPG]=0;
    KlClose[KLP_NPG]=10;
  }  
  
  
  if (StateVolts==2)                 
  {
     StateVolts=3;

    //    if (UstPower!=PowerPrev)
//    {
      // поскольку тут идет преобразование и умножение 32 разрядных чисел, делаем это по необходимости, а не каждый раз (хотя какая разница, тут и таких умножений дохрена)
      TekPower=(unsigned long) UstPower*220*220/ Power;
//      PowerPrev=UstPower;
//    }

    SqNapr=0;
    SqNaprPrev=0;    
    FindPower=TekPower*index_input;
    j=0;
    TimeOpenTriac1=0;


    if (Power>UstPower)
    {
      for(i=index_input-1;i>=0;i--)
      {
        SqNapr=SqNapr+(unsigned long) data_adc[i]* (unsigned long) data_adc[i];
        if (SqNapr>=FindPower) 
        { 
          // Рассчитали среднеквадратичное
          TimeOpenTriac1=tic_adc[i]+ (SqNapr-FindPower)*(tic_adc[i+1]-tic_adc[i])/(SqNapr-SqNaprPrev);
          // Присвоили текущие значения
          TimeOpenTriac=TimeOpenTriac1;
          TicSqNapr=tic_adc[index_input-1]; // Количство тиков таймера, на основании которого расчитано среденеквадратичное.
          j=i;
          break;
        }
        SqNaprPrev=SqNapr;
      } 
      
      #ifdef TEST
      
        Serial1.println("VOLTS");
        Serial1.print("COUNT=");
        Serial1.println(index_input);
        
        for(i=0;i<index_input;i++)
        {            
        
            Serial1.print(tic_adc[i]);
            Serial1.write(9);
            Serial1.println(data_adc[i]);
        }                                                    
        Serial1.print("TICZERO=");
        Serial1.write(9);
        Serial1.print(TicZero);
        Serial1.write(9);
        Serial1.println(TicSqNapr);
        
        Serial1.println("ENDVOLTS");
            
      
      #endif      
      
  //    SqVoltsCalibration=((long) SrVolts*10)/(9*CountSrVolts);
      
      
    }
   StateVolts=4;
  }

}





